﻿using Microsoft.AspNetCore.Http;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 컨텐트 생성 미들웨어
    /// </summary>
    public class ContentMiddleware
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 다음 미들웨어
        /// </summary>
        private RequestDelegate next;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ContentMiddleware(next)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="next">다음 미들웨어</param>
        public ContentMiddleware(RequestDelegate next)
        {
            this.next = next;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 호출하기 - Invoke(context)

        /// <summary>
        /// 호출하기
        /// </summary>
        /// <param name="context">HTTP 컨텍스트</param>
        /// <returns>태스크</returns>
        public async Task Invoke(HttpContext context)
        {
            if(context.Request.Path.ToString().ToLower() == "/hello")
            {
                await context.Response.WriteAsync("<h1>Hello from ContentMiddleware.</h1>");
            }
            else
            {
                await next.Invoke(context);
            }
        }

        #endregion
    }
}